const fse = require('fs-extra');
const path = require('path');
const symbols = require('log-symbols')

const jsonConfig = {
  'listvue': 'src/renderer/page/manage/desk',
  'listjs': 'src/renderer/page/manage/desk',
  'reportvue': 'src/renderer/page/manage/diagnosis/operate/reportTemplate/structure',
  'reportjs': 'src/renderer/models/report/temp',
}

const configPath = path.resolve(__dirname,'../config.json')

async function defConfig() {
  try {
    await fse.outputJson(configPath, jsonConfig)
  } catch (err) {
    console.error(err)
    process.exit()
  }
}

async function setMirror(name, link) {
  const exists = await fse.pathExists(configPath)
  if (exists){
    mirrorAction(name, link)
  }else{
    await defConfig()
    mirrorAction(name, link)
  }
}

async function mirrorAction(name, link){
  try {
    const jsonConfig = await fse.readJson(configPath)
    jsonConfig[name] = link
    await fse.writeJson(configPath, jsonConfig)
    console.log(symbols.success, 'Set the mirror successful.')
  } catch (err) {
    console.log(symbols.error, chalk.red(`Set the mirror failed. ${err}`))
    process.exit()
  }
}

module.exports = setMirror
